{********************************************************}
{* Configuration unit for LANMsgServer and LANMsgClient *}
{********************************************************}

unit config;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type
  {**********}
  { TfConfig }
  {**********}
  TfConfig = class(TForm)
    Label1, Label2, Label3: TLabel;
    edIP, edPort: TEdit;
    btSave: TButton;
    btCancel: TButton;
    procedure FormActivate(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
  private
    iPortSave: Word;
    sIPSave: string;
  public
    iServerPort: Word;
    sServerIP, sButton: string;
  end;

var
  fConfig: TfConfig;

implementation

{$R *.lfm}

{**********}
{ TfConfig }
{**********}

{ Form becoming active: Save actual IP and port }

procedure TfConfig.FormActivate(Sender: TObject);

begin
  if edPort.Text = '' then
    iPortSave := 0
  else
    iPortSave := StrToInt(edPort.Text);
  sIPSave := edIP.Text;
end;

{ Button "Save": Set new IP and port (and close the window) }

procedure TfConfig.btSaveClick(Sender: TObject);

var
  Mess: string;

begin
  if edPort.Text = '' then
    iServerPort := 0
  else
    iServerPort := StrToInt(edPort.Text);
  sServerIP := edIP.Text;
  if (iServerPort = 0) or (sServerIP = '') then begin
    // Missing IP and/or port: Do nothing
    if iServerPort = 0 then begin
      Mess := 'Invalid or missing port!';
      edPort.SetFocus;
    end
    else begin
      Mess := 'Missing IP address!';
      edIP.SetFocus;
    end;
    MessageDlg('Configuration error', Mess, mtError, [mbOK], 0);
  end
  else begin
    // IP and port filled in: Close the window
    sButton := 'save';
    Close;
  end;
end;

{ Button "Cancel": Restore initial IP and port (and close the window) }

procedure TfConfig.btCancelClick(Sender: TObject);

begin
  iServerPort := iPortSave;
  sServerIP := sIPSave;
  sButton := 'cancel';
  Close;
end;

end.

